;;;;
;;;; d e f e r r e d . s c m    -- deferred evaluation
;;;;
;;;; Copylefted under the GPL
;;;;
;;;;           Author: Francois-Rene Rideau [rideau@unice.fr]

(provide 'deferred)
(require 'debug)

(define pending-evaluations '())
(define (reset-deferred) (set! pending-evaluations '()))
(define (defer sexp)
  (cons! sexp pending-evaluations))
(define (make-definition name body)
  (defer `(define ,name ,body)))
(define (eval-deferred)
  (for-each eval (reverse pending-evaluations)))


(*test-on*)
(*test* ((constr:deconstr #t)
	 #f)
	((constr:deconstr (make-appl 'f 'x))
	 (((magic) appl) f x))
)
